#import <stdlib.h>
#import <math.h>
#import <string.h>

#import "RDebug.h"

#import "Agent.h"
#import "Model.h"
#import "Pop.h"
#import "World.h"
#import "Org.h"

int NextAgentId = 0;

@implementation Agent

-(unsigned int) getId { return Id; }
-(unsigned int) getrank { return rank; }
-(double) getE { return E;}
-(id) getpop { return pop; }
-(id) getattachedChoice { return attachedChoice; }
-(unsigned int) getactivityCnt { return activityCnt; }
-(unsigned int) getrestingCnt { return restingCnt; }
-(double) getunusedE { return unusedE; }

-setId: (unsigned int) i { Id = i; return self; }
-setrank: (unsigned int) r { rank = r; return self; }
-setE: (double) e { E = e; return self; }
-setpop: (id) o { pop = o; return self; }
-setorg: (id) o { org = o; return self; }


/////////////////////////////////////////////////////////////
// tryAttachToOpenChoicesOfOrg
// 
// NOTE 1996 April 2: I don't think the following comment is right.
//    I think it DOES unattach at each step.
//
// Note: don't unattach previous choice until after
//   choose new one (or none).
//   AND only detach from choice if attach to new choice.
// Note: activityCnt goes up for any change (after T=1).

-tryAttachToOpenChoicesOfOrg: (id) Orgz {
	id	   		ch;
	id			lastch = attachedChoice;

	if ( (ch = [Orgz getLeastNeedyChoiceForAgent: self]) ) {
		DMsg2(3,"   ---tryAttachToOpenChoices attaching agnt %u to ch %u.\n",
			   Id, [ch getId] );
		if ( lastch ) {
			if ( ch != lastch ) {
				[lastch remAttachedAgent: self];
				attachedChoice = ch;
				[ch addAttachedAgent: self];
			}
		}
		else { // no last choice, but choice now
			attachedChoice = ch;
   			[ch addAttachedAgent: self];
		}
	}
	else { // nothing its eligible to attach to this step...
		attachedChoice = ch = nil;
	}

	if ( lastch != ch && [[org getmodel] getT] > 1 )
		++activityCnt;

#ifdef THIS  // pre 1996 April 2
	if ( (ch = [Orgz getLeastNeedyChoiceForAgent: self]) ) {
		DMsg2(3,"   ---tryAttachToOpenChoices agnt %u, ch %u.\n",
			   Id, [ch getId] );
		if ( lastch ) {
			if ( ch != lastch ) {
				[lastch remAttachedAgent: self];
				attachedChoice = ch;
				[ch addAttachedAgent: self];
			}
		}
		else { // no last choice, but choice now
			attachedChoice = ch;
   			[ch addAttachedAgent: self];
		}
	}

	if ( lastch != ch && [[org getmodel] getT] > 1 )
		++activityCnt;
#endif
	return self;
}

/////////////////////////////////////////////////////
// updateStats
// called at end of T step

-updateStats {

	if ( !attachedChoice ) {
		++restingCnt;
		unusedE += E * [org getsolnCoeffForT: [[org getmodel] getT]];
	}

	return self;
}

//////////////////////////////////////////////////////
// createEnd
// assign an Id, set up any initial state.

-createEnd: (id) aZone {
	activityCnt = restingCnt = 0;
	unusedE = 0.0;
	return self;
}

////////////////////////////////////////////////
// debugging routines

-displayInBuff: (char *) buff {
	sprintf( buff, "Agent %2u:  rank %2u E/t  %.2f  actCnt %u.\n",
			 Id, rank, E, activityCnt );
	return self;
}

@end

