#import <swarmobject.h> 

// Some Approx tests useful for making this
// model dock with the fortran version!
#define ApproxEqDelta   0.00001
#define ApproxEq(A,B)  (A-ApproxEqDelta<=B && B<=A+ApproxEqDelta)
#define ApproxGE(A,B)  (A>=B-ApproxEqDelta)

// for collecting data in format of fortran program
#define GCanHistorySz 32
extern int ChoiceHistory[GCanHistorySz][GCanHistorySz];
extern int DMHistory[GCanHistorySz][GCanHistorySz];
extern int ProbHistory[GCanHistorySz][GCanHistorySz];

@interface Org: SwarmObject {
	id				openChoices;
	id				openProblems;
	id				madeChoices;
	id				solvedProblems;
	double	   	*solnCoeffs; // one per T required
	id		   	agents;	// just points to Pop agents
	id			model;
	id			world;
	id			pop;
}

-addOpenProblem: (id) p;
-solveProblem: (id) p;
-addOpenChoice: (id) ch;
-makeChoice: (id) ch;
-setStrsForChoice: (id) ch;
-setStrsForProblem: (id) prob;
-(BOOL) agent: (id) Ag eligibleForChoice: (id) Ch;
-(BOOL) problem: (id) Pr eligibleForChoice: (id) Ch;
-getLeastNeedyChoiceForProblem: (id) prob;
-getLeastNeedyChoiceForAgent: (id) agnt;

-(double) getsolnCoeffForT: (unsigned int) t;

-createEnd: (id) aZone;
-printstepReportFormat: (FILE *) RF;
-stepReport: (FILE *) RF;
-printFinalReport: (FILE *) RF;

-(id) getopenChoices;
-(id) getopenProblems;
-(id) getmadeChoices;
-(id) getsolvedProblems;
-(id) getagents;

-(id) getmodel;
-(id) getworld;
-(id) getpop;

-setagents: (id) o;
-setworld: (id) o;
-setmodel: (id) o;
-setpop: (id) o;

-displayOrgOn: (FILE *) RF;

@end
