
#import <swarmobject.h>
#import <collections.h>

// ==> if you change these, change ParameterTypeNames 
// ==> in RParameter.m !!
typedef enum { charPar, stringPar, boolPar, shortPar, intPar, 
		unsignedPar, floatPar, doublePar, longPar } ParameterType;

union RParValue {
		double	 d; unsigned u; float f;       short s; char c;
		int		 i; BOOL	 b;	char  *string; long  l;
};

@interface RParameter: SwarmObject {
	id				pzone;
	id				parameters;		// object this is in
	char			*Name, *Alias;
	ParameterType  	Type;
	union RParValue value;
	char			*ValueString;		
	SEL		    	setFn;
	int				HasLB, HasUB;
	double			LB, UB;
	char	   		*Desc;
}

+createBegin: (id) aZone;
-setpzone: (id) azone;
-setName: (char *) name Aka: (char *) A
	Type: (ParameterType) type  Value: (char *) v;
-setLB: (double) db;
-setUB: (double) db;
-createEnd: (id) aModel;

-(char *) getName;
-(char *) getAlias;
-(char *) getValueString;

-(int) setValueTo: (char *) v;
-(int) getIValue;
-(double) getDValue;
-(char *) getStrValue;
-(BOOL) getBValue;
-(unsigned int) getUValue;
-(char) getCValue;

-setDesc: (char *) desc;
-(char *) getTypeString;

-setsetFn: (SEL) aSel;

@end

// The following gives public access to parameter value
// addresses within their RParameter object instances.
// For example, suppose p points to an RParameter instance
// for an unsigned parameter value.  To read it:
//     printf( "  ==>   URPA(p) %u.\n\n", *(URPA(p)) );
// To set it:
//     *(URPA(p)) = 3;
// But note the string value doesn't get set!
// Caller must do that, too.

struct RParameterDef {
	@defs(RParameter)
} *publicRParameter;

#define URPA(P) &(((struct RParameterDef *)P)->value.u)
#define DRPA(P) &(((struct RParameterDef *)P)->value.d)
#define FRPA(P) &(((struct RParameterDef *)P)->value.f)
#define SRPA(P) &(((struct RParameterDef *)P)->value.s)
#define IRPA(P) &(((struct RParameterDef *)P)->value.i)
#define CRPA(P) &(((struct RParameterDef *)P)->value.c)
#define BRPA(P) &(((struct RParameterDef *)P)->value.b)
#define LRPA(P) &(((struct RParameterDef *)P)->value.l)
#define STRPA(P) &(((struct RParameterDef *)P)->value.string)
