// The World, Problems and Choices objects 

#import <swarmobject.h> 

@interface World: SwarmObject {

	id			choices;
	id			problems;

	id			model;
	id			org;
	id			pop;
}

-activateNewProblemsFor: (id) org ReportOn: (FILE *) RF;
-activateNewChoicesFor: (id) org ReportOn: (FILE *) RF;

-createEnd: (id) aZone;
-initProblemsAndChoices: (id) aZone;

-(id) getmodel;
-(id) getorg;
-(id) getpop;

-setorg: (id) o;
-setmodel: (id) o;
-setpop: (id) o;

@end  // ========= end World object =========================


////////////////////////////////////////////////////////////
// Problem object

@interface Problem: SwarmObject {
	unsigned int	Id;
	unsigned int   	entryTime, solveTime;
	unsigned int   	importance;
	double		   	requiredE;
	unsigned int   	activityCnt, latencyCnt;
	unsigned int	attachedPeriodCnt;
	id			   	attachedChoice, attachedChoicePrev;
	id			   	org;
}

-tryAttachToOpenChoicesOfOrg: (id) Orgz;
-updateOpenStats;

-createEnd: (id) aZone;

-setId: (unsigned) i;
-setentryTime: (unsigned) t;
-setimportance: (unsigned) i;
-setsolveTime: (unsigned) t;
-setrequiredE: (double) e;
-setactivityCnt: (unsigned int) c;
-setlatencyCnt: (unsigned int) c;
-setorg: (id) o;

-(unsigned int) getentryTime;
-(unsigned int) getimportance;
-(unsigned int) getId;
-(unsigned int) getsolveTime;
-(double) getrequiredE;
-(unsigned int) getactivityCnt;
-(unsigned int) getlatencyCnt;
-(unsigned int) getattachedPeriodCnt;
-(id) getorg;
-(id) getattachedChoice;
-(id) getattachedChoicePrev;

-displayInBuff: (char *) buff;

@end  // ===========  end Problem object ===================

////////////////////////////////////////////////////////////
// Choice object

@interface Choice: SwarmObject {
	unsigned int   	Id;
	unsigned int   	entryTime, decisionTime;
	unsigned int   	importance;
	double		   	requiredE;	// sum of attached problems
	double		   	attachedE;  // sum of attached agents (mod solnCoeff)
	char		   	choiceMethod;	// Resolution,Oversite,Flight,Both(R,F)
	unsigned int	attachedProblemsCntMax; // max *ever* attached
    unsigned int	attachedProblemsCnt;    // current
	BOOL			fled; // 1 if ever max > cur
	id			   	attachedAgents, attachedProblems;
	id				eligibleAgents, eligibleProblems;
	id			   	org;
}

-createEnd: (id) aZone;
-updateE;
-(BOOL) tryMakeChoice;

-addAttachedAgent: (id) agnt;
-remAttachedAgent: (id) agnt;
-addAttachedProblem: (id) prob;
-remAttachedProblem: (id) prob;
-addEligibleAgent: (id) agnt;
-addEligibleProblem: (id) prob;

-setId: (unsigned) i;
-setentryTime: (unsigned) t;
-setimportance: (unsigned) i;
-setdecisionTime: (unsigned) t;
-setrequiredE: (double) e;
-setattachedE: (double) e;
-setorg: (id) o;
-setfled: (BOOL) b;
-setchoiceMethod: (char) c;

-(unsigned int) getentryTime;
-(unsigned int) getimportance;
-(unsigned int) getId;
-(unsigned int) getdecisionTime;
-(double) getrequiredE;
-(double) getattachedE;
-(double) getwastedE;
-(char) getchoiceMethod;
-(id) getorg;
-(id) geteligibleAgents;
-(id) getattachedAgents;
-(id) geteligibleProblems;
-(id) getattachedProblems;
-(unsigned int) getattachedProblemsCnt;
-(unsigned int) getattachedProblemsCntMax;
-(BOOL) getfled;

-displayInBuff: (char *) buff;

@end










